mod display;
pub mod loader;
pub mod unloader;

mod constants;

mod tests;

/// Represents a section, or symbol, that must end up in the
/// binary file.
#[derive(Debug)]
pub struct Section<'a> {
    /// Name of the symbol/section
    name: String,
    /// Content in bytes
    content: &'a [u16],
}

impl Section<'_> {
    pub fn new<'a>(name: String, content: &'a [u16]) -> Section<'a> {
        Section { name, content }
    }
}
